#pragma once
#include "LightBase.h"

ref class SpotLight : public LightBase
{
internal:
	SpotLight(void);

	virtual void Initialize(ID3D11PixelShader* pixelShader, ID3D11Buffer* lightParametersBuffer, ID3D11Buffer* spotLightDetailsBuffer) override;

	void LightPosition(float x, float y, float z);
	DirectX::XMFLOAT3 LightPosition(void);

	void LightRange(float range);
	float LightRange(void);

	void AttenuationConstants(float constant, float linear, float quadratic);
	DirectX::XMFLOAT3 AttenuationConstants(void);

	virtual void Render(ID3D11DeviceContext* context, UINT indexCount = 6, UINT startIndexLocation = 0, UINT baseVertexLocation = 0) override;

	virtual float GetDepthForSorting(const DirectX::XMFLOAT4X4& viewMatrix) override;

protected private:
	DirectX::XMFLOAT4							m_lightPositionAndRange;
	DirectX::XMFLOAT4							m_lightDirection;
	DirectX::XMFLOAT4							m_attenuationConstants;
	Microsoft::WRL::ComPtr<ID3D11Buffer>		m_pointLightDetailsBuffer;

private:
	bool										m_updateRequired;
};

