Texture2D diffuseTexture : register(t0);
SamplerState linearSampler : register(s0);

cbuffer GlassShatterOnWindowSizeChange : register(b0)
{
	float4x4 projection  : packoffset(c0);
	float4 ambientColor  : packoffset(c4);
	float4 diffuseColor  : packoffset(c5);
	float3 specularColor : packoffset(c6.x);
	float specularPower	 : packoffset(c6.w);
	float3 lightPosition : packoffset(c7.x);
	float fadeOutTime    : packoffset(c7.w);
};

cbuffer GlassShatterPerFrame : register(b1)
{
	float4x4 view : packoffset(c0);
	float rotationAmount : packoffset(c4.x);
	float translationAmount : packoffset(c4.y);
	float time : packoffset(c4.z);
	float3 eyePosition : packoffset(c5);
};

cbuffer GlassShatterPerMesh : register(b2)
{
	float4x4 world;
};

struct GlassShatterInputPS
{
	float4 Position : SV_POSITION;
	float3 WorldNormal : TEXCOORD0;
	float3 WorldPosition : TEXCOORD1;
	float2 TexCoords : TEXCOORD2;
	float4 Color : COLOR0;
};

struct GlassShatterInputVS
{
	float3 Position : POSITION;
	float3 Normal : NORMAL;
	float2 TexCoords : TEXCOORD0;
};

struct GlassShatterInputGS
{
	float4 Position : SV_POSITION;
	float3 Normal : NORMAL;
	float2 TexCoords : TEXCOORD0;
};
