Texture2D lightBuffer : register(t0);
Texture2D diffuseTexture : register(t1);

SamplerState linearSampler : register(s0);
SamplerState pointSampler : register(s1);

cbuffer LightFinalPassOnWindowSizeChange : register(b0)
{
	float4x4 projection;
};

cbuffer LightFinalPassPerFrame : register(b1)
{
	float4x4 view;
	float4 ambientColor;
};

cbuffer LightFinalPassPerMesh : register(b2)
{
	float4x4 world;
	float3 specularColor;
	float4 diffuseTint;
	float4 overrideColor;
	float4 overridePercentAndDiffusePercent;
};


struct LightFinalPassInputVS
{
	float4 position : POSITION;
	float3 normal : NORMAL0;
	float2 texCoord : TEXCOORD0;
};

struct LightFinalPassInputPS
{
	float4 position : SV_Position;
	float2 texCoord : TEXCOORD0;
	float4 positionScreen : TEXCOORD1;
};
