Texture2D positionTexture : register(t0);
Texture2D normalTexture : register(t1);

SamplerState pointSampler : register(s0);

cbuffer LightPassChangeOnResize : register(b0)
{
    row_major float4x4 TransformationMatrix;
};

cbuffer LightPassLightParameters : register(b1)
{
	float3 lightColor : packoffset(c0.x);
	float lightFalloff : packoffset(c0.w);
};

cbuffer LightPassViewParameters : register(b2)
{
	float3 viewPosition;
};

struct LightPassInputVS
{
	float4 position : POSITION;
	float2 texCoord : TEXCOORD0;
};

struct LightPassInputPS
{
	float2 texCoord : TEXCOORD0;
	float4 position : SV_Position;
};
