Texture2D normalMap : register(t0);
SamplerState linearSampler : register(s0);

cbuffer LightPrePassOnWindowSizeChange : register(b0)
{
	float4x4 projection;
};

cbuffer LightPrePassPerFrame : register(b1)
{
	float4x4 view;
};

cbuffer LightPrePassPerMesh : register(b2)
{
	float4x4 world;
	float specularPower;
};

struct PNTInputVS
{
	float4 position : POSITION;
	float3 normal : NORMAL0;
	float2 texCoord : TEXCOORD0;
};

struct PNTInputPS
{
	float4 position : SV_POSITION;
	float3 normalWorld : NORMAL0;
	float2 texCoord : TEXCOORD0;
	float3 positionWorld : POSITION1;
};

struct PNTBTInputVS
{
	float4 position : POSITION;
	float3 normal : NORMAL0;
	float2 texCoord : TEXCOORD0;
	float3 bitangent : BINORMAL0;
	float3 tangent : TANGENT0;
};

struct PNTBTInputPS
{
	float4 position : SV_POSITION;
	float3 normalWorld : NORMAL0;
	float2 texCoord : TEXCOORD0;
	float3 bitangentWorld : BITANGENT0;
	float3 tangentWorld : TANGENT0;
	float3 positionWorld : POSITION1;
};

struct PrePassOutputPS
{
	float4 position : SV_Target0;
	float4 normal : SV_Target1;
};
